var React = require('react');
var NotificationItem = require('./notification-item');
var Constants = require('./constants');
var Helpers = require('./helpers');

var NotificationContainer = React.createClass({displayName: "NotificationContainer",

  propTypes: {
    position: React.PropTypes.string.isRequired,
    notifications: React.PropTypes.array.isRequired
  },

  _style: {},

  _containerHeight: 0,

  _element: null,

  _lastNotificationHeight: 0,

  _calculateHeight: function(type, height) {
    this._containerHeight = (type === 'add') ? this._containerHeight + height : this._containerHeight - height;
    this._lastNotificationHeight = (type === 'add') ? height : -(height);

    console.log(this._lastNotificationHeight);

    this.setState({
      height: this._containerHeight
    });
  },

  _onRemove: function(uid, index) {
    console.log(index);
    this.props.onRemove(uid);
  },

  getInitialState: function() {
    return {
      height: 0
    }
  },

  componentWillMount: function() {
    // Fix position if width is overrided
    this._style = this.props.getStyles.container(this.props.position);

    if (this.props.getStyles.overrideWidth && (this.props.position === Constants.positions.tc || this.props.position === Constants.positions.bc)) {
      this._style['marginLeft'] = -(this.props.getStyles.overrideWidth / 2);
    }
  },

  componentDidMount: function() {
    this._element = React.findDOMNode(this);
    this.setState({
      height: this._containerHeight
    });
  },

  render: function() {
    var self = this;

    if (Helpers.inArray(this.props.position, [Constants.positions.tl, Constants.positions.tr, Constants.positions.tc])) {
      this.props.notifications.reverse();
    }

    this.props.notifications.map(function(notification, index){
      if (index === 0) return;
      self.props.notifications[index].topPosition = self._lastNotificationHeight;
    });

    console.log(this.props.notifications);

    this._style.height = this.state.height;

    var notifications = this.props.notifications.map(function(notification, index) {
      var _notification = (
        React.createElement(NotificationItem, {
          key: notification.uid, 
          index: index, 
          notification: notification, 
          getStyles: self.props.getStyles, 
          onRemove: self._onRemove, 
          noAnimation: self.props.noAnimation, 
          calculateHeight: self._calculateHeight}
        )
      );

      return _notification;
    });

    return (
      React.createElement("div", {className: 'notifications-' + this.props.position, style: this._style}, 
        notifications
      )
    );
  }
});


module.exports = NotificationContainer;
